#!/bin/bash

. $MX_SCRIPT_PATH/mx_global.sh
. $MX_SCRIPT_PATH/snmp/global.sh

TABLE=$mx_bios_mgmt_table
BIOS_TOOL="$MX_SCRIPT_PATH/snmp/bSNMP.elf"
gb_debug_enable=0

############################################

bios_mgmt_pwrOnAfterPwrFail()
{
	local NAME="pwrOnAfterPwrFail"
	local OID="4.8.1"
	
	# 1. Get New setting value
	local NewValue=`gb_sql_query "SELECT newValue FROM $TABLE WHERE name='$NAME'"`

	# 2. Set New value by using bSNMP.elf
	$BIOS_TOOL -i $OID,$NewValue

	# 3. Update setting
	local Value=`$BIOS_TOOL -i $OID | sed -n "s:\(.*\)\r:\1:p"`
	local query="UPDATE $TABLE SET curValue='$Value' WHERE name='$NAME'"
	gb_debug "$query"
	gb_sql_query "$query"
}

bios_mgmt_pwrLanWakeUp()
{
	local NAME="pwrLanWakeUp"
	local OID="4.8.3"
	
	# 1. Get New setting value
	local NewValue=`gb_sql_query "SELECT newValue FROM $TABLE WHERE name='$NAME'"`

	# 2. Set New value by using bSNMP.elf
	$BIOS_TOOL -i $OID,$NewValue

	# 3. Update setting
	local Value=`$BIOS_TOOL -i $OID | sed -n "s:\(.*\)\r:\1:p"`
	local query="UPDATE $TABLE SET curValue='$Value' WHERE name='$NAME'"
	gb_debug "$query"
	gb_sql_query "$query"
}

bios_mgmt_firstBootDevice()
{
	local NAME="firstBootDevice"
	
	# 1. Get New setting value
	local NewValue=`gb_sql_query "SELECT newValue FROM $TABLE WHERE name='$NAME'"`

	# 2. Set New value by using bSNMP.elf
	$BIOS_TOOL -f $NewValue &> /dev/null

	# 3. Update Boot Sequence in database
	local Value=`$BIOS_TOOL -b | sed -n "s:\(.*\), \r:\1:p"`
	local query="UPDATE $TABLE SET curValue='$Value',newValue='$Value' WHERE name='bootDeviceStatus'"
	gb_debug "$query"
	gb_sql_query "$query"

	# 4. Update Setting
	local query="UPDATE $TABLE SET newValue='1' WHERE name='$NAME'"
	gb_debug "$query"
	gb_sql_query "$query"
}

############################################

saveSetting=`gb_sql_query "SELECT newValue FROM $TABLE WHERE name='biosSaveSetting'"`

if [ "$saveSetting" == "0" ]; then
	# case: none
	# wade add for control table status
	gb_control_table_clear $TABLE
	exit
elif [ "$saveSetting" == "1" ]; then
	# case: apply
	modified_ids=`gb_sql_query "SELECT id FROM $TABLE WHERE status='1'"`
	for id in $modified_ids; do
		gb_sql_import_row_var "SELECT * FROM $TABLE WHERE id='$id'"
		if [ "$name" == "biosSaveSetting" ]; then
			continue
		fi
#R00		bios_mgmt_$name
#R00		query="UPDATE $TABLE SET status='0' WHERE id='$id'"
#R00-start
		query="UPDATE $TABLE SET status='0',CurValue='-1',NewValue='-1' WHERE id='$id'"
#R00-end
		gb_debug "$query"
		gb_sql_query "$query"
	done
	query="UPDATE $TABLE SET status='0',curValue='0',newValue='0' WHERE name='biosSaveSetting'"
	gb_debug "$query"
	gb_sql_query "$query"

	# wade add for control table status
	gb_control_table_clear $TABLE

elif [ "$saveSetting" == "2" ]; then
	# case: discard
	modified_ids=`gb_sql_query "SELECT id FROM $TABLE WHERE status='1'"`
	gb_debug "modified_ids=$modified_ids"
	for id in $modified_ids; do
		gb_sql_import_row_var "SELECT * FROM $TABLE WHERE id='$id'"
		query="UPDATE $TABLE SET status='0',newValue='$curValue' WHERE id='$id'"
		gb_debug "$query"
		gb_sql_query "$query"
	done

	# wade add for control table status
	gb_control_table_clear $TABLE
fi

