#!/bin/bash
################################################# 
# Update Sensor Table
# TODO:
#   
#################################################
. $MX_SCRIPT_PATH/mx_global.sh
. $MX_SCRIPT_PATH/snmp/global.sh

TABLE="$mx_sensor_mgmt_table"
BIOS_TOOL="$MX_SCRIPT_PATH/snmp/bSNMP.elf"

#################################################
# STARTING POINT:
#################################################


# Get Temperature Sensor support count
Count=`$BIOS_TOOL -t | sed -n "s:Count\: \(.*\)\r:\1:p"`
Count=$(($Count-1))

# Loop to update Temperature data
for i in `seq 0 1 $Count`; do
	# Get Data Name of each Temperature Data
	Name=`$BIOS_TOOL -t$i | sed -n "s:\(.*\)\: \(.*\)\r:\1:p"`
	
	# Get Data Value of each Temperature Data
	Value=`$BIOS_TOOL -t$i | sed -n "s:\(.*\)\: \(.*\)\r:\2:p"`

#R00-start
	if [ "$Value" -ge "126000" -o "$Value" -le "-56000" ]; then
		Name="NONE"
		Value=0
	fi
#R00-end

	# Get the records from Table
	Record=`gb_sql_query "SELECT value FROM $TABLE WHERE type=0 AND number=$i"`

	# If new value is equal to database's record, do not update the database
	if [ "$Value" != "$Record" ]; then
		# Update Name/Value of each Temperature Data into Database
		Query="UPDATE $TABLE SET name='$Name', value='$Value' WHERE type=0 AND number=$i"
		gb_sql_query "$Query"
	fi
done

# Get Voltage Sensor support count
Count=`$BIOS_TOOL -o | sed -n "s:Count\: \(.*\)\r:\1:p"`
Count=$(($Count-1))

# Loop to update Voltage data
for i in `seq 0 1 $Count`; do
	# Get Data Name of each Voltage Data
	Name=`$BIOS_TOOL -o$i | sed -n "s:\(.*\)\: \(.*\)\r:\1:p"`
	
	# Get Data Value of each Voltage Data
	Value=`$BIOS_TOOL -o$i | sed -n "s:\(.*\)\: \(.*\)\r:\2:p"`

	# Get the records from Table
	Record=`gb_sql_query "SELECT value FROM $TABLE WHERE type=1 AND number=$i"`

	# If new value is equal to database's record, do not update the database
	if [ "$Value" != "$Record" ]; then
		# Update Name/Value of each Voltage Data into Database
		Query="UPDATE $TABLE SET name='$Name', value='$Value' WHERE type=1 AND number=$i"
		gb_sql_query "$Query"
	fi
done

