#!/bin/bash
################################################# 
# Call all scripts
#################################################
. $MX_SCRIPT_PATH/mx_global.sh
. $MX_SCRIPT_PATH/snmp/global.sh

# Save the db every hour
MX_TIME2SAVE=36000

count=0
gb_debug_enable=0


#TODO: the sleep here may not so correct as you see,
# this is because each script command need time to execute
# may you can change it better
while true; do

	#this may need 100ms
	#gb_debug_time "start"

	# per second
	val=`expr $count \% 10`
	if [ "$val" -eq "0" ]; then
		gb_debug "----trigger per second"
		$MX_SCRIPT_PATH/snmp/mx_usb_update.sh 
	fi

	# per 10 second
	val=`expr $count \% 100`
	if [ "$val" -eq "0" ]; then
		gb_debug "----trigger per 10 second"
		$MX_SCRIPT_PATH/snmp/mx_sensor_update.sh  
	fi

	val=`expr $count \% 50`
	if [ "$val" -eq "0" ]; then
		gb_debug "----trigger per 5 second"
		$MX_SCRIPT_PATH/snmp/mx_system_info.sh
	fi

	# save to DB
	val=`expr $count \% $MX_TIME2SAVE`
	if [ "$val" -eq "0" ]; then
		gb_debug "----trigger per hour"
		# mount -o remount,rw /
		sqlite3 /dev/shm/snmp.db ".dump" > /etc/mxAgent/db/.moxa.sql
		result=`grep -r "ERROR: (5) database is locked" /etc/mxAgent/db/.moxa.sql`
		while [ x"$result" != x"" ];
		do
			:> /etc/mxAgent/db/.moxa.sql
			sqlite3 /dev/shm/snmp.db ".dump" > /etc/mxAgent/db/.moxa.sql
			result=`grep -r "ERROR: (5) database is locked" /etc/mxAgent/db/.moxa.sql`
			sleep 1
		done              
		mv /etc/mxAgent/db/.moxa.sql /etc/mxAgent/db/snmp.sql
		# umount /
	fi

	# reset per 100s
	if [ "$count" -eq "$MX_TIME2SAVE" ]; then
		count=0
	fi
	count=`expr $count + 1`

	sleep 0.1
done
